// RELOJ DE TIEMPO REAL PARA SISTEMA MON AMI
// MUESTRA HORAS Y MINUTOS EN EL PANEL DE LEDS.
// PARPADEA LOS DOS PUNTOS CADA SEGUNDO
// LA HORA INICIAL SE INTRODUCE A TRAVES DEL
// PUERTO SERIAL, ENVIANDO EL COMANDO "A" Y
// TECLEANDO POR TERMINAL LA HORA. EJ: 15:23

#include "16F88adc.h" 
#include "keyadc.h"
#include <stdio.h>
#use delay(clock=4000000) 
#use rs232 (baud=9600,xmit=PIN_B5,rcv=PIN_B2)

//RTC variables 
#define CRISTAL  4000000 
#define FRECUENCIA_TIMER1 (CRISTAL / 4)  // 1 tick = frecuencia del cristal/4 
int32 Ticker; 
int8 Segundos=0; 
char matrix[7]="00:00";		//HORA INICIAL 
int8 Year=0,Mes=0,Dia=0,Hora=16,Minuto=34; 
#define BISIESTO(year) (year%4 == 0)

//MON AMI VARIABLES
void renglones(void);
void reset(void);
void pulso(void);
char timed_getc(); 
int i;					//variable ndice malla principal 
int k;					//variable ndice para arreglo pf[]
int bo;
int ze;
int jota=0;				//variable indice para arreglo pf[]
char pf[30]; 
#include "LETRASCCS4.h"

void DISPLAY_LCD(void)
{ 

   RA2=0;         //dato=0	para ingresar un 0 a primera columna
   pulso();       //COLUMNA 0=0 el 0 se va a ir corriendo al resto de las columnas
   RA2=1;         //dato=1  ingresan 1 a registros a cada incremento.
   for (i=0;i<=29;i++)     //Hacemos el barrido de columnas.
   {                                       
      bo=pf[i];            	//Barremos la variable que contiene los datos para escribir en las matrices.
      renglones();           //Manda el dato de 7 renglones.
	  ze=timed_getc();
				if (ze=='A')
				{PORTB=0;RA4=0;delay_ms(300);
				disable_interrupts(GLOBAL);
				printf("ANTES DE 1 SEGUNDO, DE CLICK EN OPCION WRITE FLASH\r\n");
				#ASM					//ENTRA EN MODO BOOTLOADER
				GOTO 0;
				#ENDASM
				}
				if (ze=='B')
				{PORTB=0;RA4=0;
				printf("PROPORCIONE LA HORA:\r\n");
				for(i=0;i<5;i++)
				{matrix[i]=getchar();	//recibe un caracter de puerto		
				putchar(matrix[i]);		//enva caracter a puerto serie
				}
				printf("\r\nOK\r\n");delay_ms(100);
				Hora=(matrix[0]-0x30)*10+(matrix[1]-0x30);
				Minuto=(matrix[3]-0x30)*10+(matrix[4]-0x30);
				}
      delay_us(200);
      pulso();             //activa siguiente columna 
	  PORTB=0;				//evita que encienda brevemente la sig. columna
      RA4=0; 
   }	
}


//Inicializa TIMER1  

void Inicializa_RTC(void) 
{ 
  Ticker = FRECUENCIA_TIMER1;                 // 1 Tick = 1 us. 
  setup_timer_1( T1_INTERNAL | T1_DIV_BY_1 ); // initializa TIMER1 para interrupcin 
                                              // cada 65536 us.                                              
  enable_interrupts( INT_TIMER1 );            // habilita interrupcin TIMER1 
} 

//AQUI INICIA LA SUBRUTINA DE INTERRUPCION DEL TIMER 1  
//EL ALGORITMO ES EXACTO.

#int_TIMER1                                
void TIMER1_isr()                          //subrutina de interrupcin.
{ 
  Ticker -= 65536;                        // Decrementa ticker 
  if ( Ticker < 65536 )                   // Si ya pas 1 segundo 
  {  Ticker += FRECUENCIA_TIMER1;          //   Incrementa ticker 
     Segundos++;                           //   Incrementa segundos 
  } 
  
  if(Segundos == 60) {Minuto++; Segundos=0; 
    if(Minuto == 60) {Hora++; Minuto=0; 
      if(Hora == 24) {Dia++; Hora=0; 
        if (  (Dia == 29 && Mes==2 && !BISIESTO(Year)) 
           || (Dia == 30 && Mes==2) 
           || (Dia == 31 && (Mes==4 || Mes==6 || Mes==9 || Mes==11 )) 
           || (Dia == 32) 
           ) {Mes++;Dia=0;} 
        	if(Mes == 13) {Year++; Mes=0;} 
  }}}   
} 

// PROGRAMA PRINCIPAL  

#rom 0X0000={0X018A,0X28FF}	//DATOS REQUERIDOS POR TINY					
#build(reset=0x00FF)

void main() 
{ 
  int8 segundo_previo; 
  CVRCON=0;
  CMCON=7;
  TRISA=0;    //Configuramos puertos.
  TRISB=4;
  PORTA=0;
  PORTB=0;
bo=0;
reset();


  Inicializa_RTC(); 
  enable_interrupts(GLOBAL); 
  while(1) 
  { if (Segundos != segundo_previo) 
    {segundo_previo=Segundos; 
		if(matrix[2]==0x20)matrix[2]=0x3A;
		else matrix[2]=0x20;
    }

	matrix[3]=Minuto/10+0x30;
	matrix[4]=Minuto%10+0x30;
	matrix[0]=Hora/10+0x30;
	matrix[1]=Hora%10+0x30;
jota=0;
for(k=0;k<5;k++)
	{
	swatch(matrix[k]);		//acomoda patrn de columnas en arreglo pf[]
	if(matrix[k]=='%')goto sigue;  //si es caracter grfico,no aade rengn en blanco
	if(matrix[k]=='/')goto sigue2;
	pf[jota]=0;	
	jota=jota+1;					//deja una columna en blanco entre caracteres	
	continue;
	sigue:							//si es corazn, aade la columna que falta
	pf[jota]=0x3E;
	jota=jota+1;
	continue;
	sigue2:							//si es flecha, aade la columna que falta
	pf[jota]=0x38;
	jota=jota+1;	
	}	
	DISPLAY_LCD();			//AQUI SE ACTUALIZA LA HORA EN MON AMI  
  } 
} 

//FUNCIONES MON AMI
//ASIGNA DATO EN RENGLON A BIT DE PUERTOS:
//R0=RB0,R1=RB1,R2=RB3,R3=RB4,R4=RB6,R5=RB7,R6=RA4
//RB2 Y RB5 SE RESERVAN PARA EL PUERTO SERIAL.
void renglones(void)
{
   PORTB=0;
   RA4=0;  
   if (bit_test(bo,1)==1)      //asigna valores a bits.
   {RB0=1;}   
   if (bit_test(bo,2)==1)
   {RB1=1;}
   if (bit_test(bo,3)==1)      
   {RB3=1;}
   if (bit_test(bo,4)==1)      
   {RB4=1;}
   if (bit_test(bo,5)==1)      
   {RB6=1;}
   if (bit_test(bo,6)==1)      
   {RB7=1;}
   if (bit_test(bo,7)==1)      
   {RA4=1;}   
}

void reset(void)
{
RA0=0;
delay_ms(100);
RA0=1;
}

void pulso(void)
{
RA1=0;
RA1=1;
}

char timed_getc() 
{
long timeout;
timeout=0;
	while(!kbhit()&&(++timeout<21))   // 1 milisegundos
		delay_us(1);
		if(kbhit())			//hay caracter en buffer?
		return(getc());
		else {   
			return(0);
			}
	}